/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumAnnotationsource;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.records.TCoreAnnotationRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreAnnotation extends TableImpl<TCoreAnnotationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_annotation</code>
     */
    public static final TCoreAnnotation T_CORE_ANNOTATION = new TCoreAnnotation();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreAnnotationRecord> getRecordType() {
        return TCoreAnnotationRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_annotation.lastchange</code>.
     */
    public final TableField<TCoreAnnotationRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_annotation.source</code>.
     */
    public final TableField<TCoreAnnotationRecord, EnumAnnotationsource> SOURCE = createField(DSL.name("source"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumAnnotationsource.class), this, "");

    /**
     * The column <code>common_dd.t_core_annotation.fk_element</code>.
     */
    public final TableField<TCoreAnnotationRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_annotation.key</code>.
     */
    public final TableField<TCoreAnnotationRecord, String> KEY = createField(DSL.name("key"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_annotation.value</code>.
     */
    public final TableField<TCoreAnnotationRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB.nullable(false), this, "");

    private TCoreAnnotation(Name alias, Table<TCoreAnnotationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreAnnotation(Name alias, Table<TCoreAnnotationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_annotation</code> table
     * reference
     */
    public TCoreAnnotation(String alias) {
        this(DSL.name(alias), T_CORE_ANNOTATION);
    }

    /**
     * Create an aliased <code>common_dd.t_core_annotation</code> table
     * reference
     */
    public TCoreAnnotation(Name alias) {
        this(alias, T_CORE_ANNOTATION);
    }

    /**
     * Create a <code>common_dd.t_core_annotation</code> table reference
     */
    public TCoreAnnotation() {
        this(DSL.name("t_core_annotation"), null);
    }

    public <O extends Record> TCoreAnnotation(Table<O> path, ForeignKey<O, TCoreAnnotationRecord> childPath, InverseForeignKey<O, TCoreAnnotationRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_ANNOTATION);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreAnnotationPath extends TCoreAnnotation implements Path<TCoreAnnotationRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreAnnotationPath(Table<O> path, ForeignKey<O, TCoreAnnotationRecord> childPath, InverseForeignKey<O, TCoreAnnotationRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreAnnotationPath(Name alias, Table<TCoreAnnotationRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreAnnotationPath as(String alias) {
            return new TCoreAnnotationPath(DSL.name(alias), this);
        }

        @Override
        public TCoreAnnotationPath as(Name alias) {
            return new TCoreAnnotationPath(alias, this);
        }

        @Override
        public TCoreAnnotationPath as(Table<?> alias) {
            return new TCoreAnnotationPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<UniqueKey<TCoreAnnotationRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_CORE_ANNOTATION_SOURCE_FK_ELEMENT_KEY_KEY);
    }

    @Override
    public List<ForeignKey<TCoreAnnotationRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_ANNOTATION__T_CORE_ANNOTATION_FK_ELEMENT_FKEY);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_ANNOTATION__T_CORE_ANNOTATION_FK_ELEMENT_FKEY, null);

        return _tCoreElementHierarchy;
    }

    @Override
    public TCoreAnnotation as(String alias) {
        return new TCoreAnnotation(DSL.name(alias), this);
    }

    @Override
    public TCoreAnnotation as(Name alias) {
        return new TCoreAnnotation(alias, this);
    }

    @Override
    public TCoreAnnotation as(Table<?> alias) {
        return new TCoreAnnotation(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreAnnotation rename(String name) {
        return new TCoreAnnotation(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreAnnotation rename(Name name) {
        return new TCoreAnnotation(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreAnnotation rename(Table<?> name) {
        return new TCoreAnnotation(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreAnnotation where(Condition condition) {
        return new TCoreAnnotation(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreAnnotation where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreAnnotation where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreAnnotation where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreAnnotation where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreAnnotation where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreAnnotation where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreAnnotation where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreAnnotation whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreAnnotation whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
